diff --git a/src/backend/commands/vacuum.c b/src/backend/commands/vacuum.c
index 462f9a0f82..ee058b2b36 100644
--- a/src/backend/commands/vacuum.c
+++ b/src/backend/commands/vacuum.c
@@ -2069,6 +2069,9 @@ vacuum_delay_point(void)
 		if (msec > VacuumCostDelay * 4)
 			msec = VacuumCostDelay * 4;
 
+        elog(DEBUG2,"VACUUM Sleep: Delay: %f, CostBalance: %d, CostLimit: %i, msec: %f",
+             VacuumCostDelay,VacuumCostBalance,VacuumCostLimit,msec);
+
 		pgstat_report_wait_start(WAIT_EVENT_VACUUM_DELAY);
 		pg_usleep((long) (msec * 1000));
 		pgstat_report_wait_end();
diff --git a/src/backend/postmaster/autovacuum.c b/src/backend/postmaster/autovacuum.c
index 47e60ca561..b9bc81fe99 100644
--- a/src/backend/postmaster/autovacuum.c
+++ b/src/backend/postmaster/autovacuum.c
@@ -1854,7 +1854,7 @@ autovac_balance_cost(void)
 			 * cost_limit to more than the base value.
 			 */
 			worker->wi_cost_limit = Max(Min(limit,
-											worker->wi_cost_limit_base),
+											MAXVACUUMCOSTLIMIT),
 										1);
 		}
 
diff --git a/src/backend/utils/misc/guc.c b/src/backend/utils/misc/guc.c
index eafdb1118e..b012dffaf6 100644
--- a/src/backend/utils/misc/guc.c
+++ b/src/backend/utils/misc/guc.c
@@ -2433,7 +2433,7 @@ static struct config_int ConfigureNamesInt[] =
 			NULL
 		},
 		&VacuumCostLimit,
-		200, 1, 10000,
+		200, 1, MAXVACUUMCOSTLIMIT,
 		NULL, NULL, NULL
 	},
 
@@ -2443,7 +2443,7 @@ static struct config_int ConfigureNamesInt[] =
 			NULL
 		},
 		&autovacuum_vac_cost_limit,
-		-1, -1, 10000,
+		-1, -1, MAXVACUUMCOSTLIMIT,
 		NULL, NULL, NULL
 	},
 
diff --git a/src/include/miscadmin.h b/src/include/miscadmin.h
index 1bdc97e308..a3949823b4 100644
--- a/src/include/miscadmin.h
+++ b/src/include/miscadmin.h
@@ -254,6 +254,8 @@ extern int	VacuumCostPageDirty;
 extern int	VacuumCostLimit;
 extern double VacuumCostDelay;
 
+#define MAXVACUUMCOSTLIMIT 10000
+
 extern int64 VacuumPageHit;
 extern int64 VacuumPageMiss;
 extern int64 VacuumPageDirty;
